/* Write a program to find the sum of 8 bit variables A and B.
 * For this programming problem the sum may be less than -128 and greater than 127
 * Store the sum into 16 bit variable C using little endian byte ordering.
 * C = A + B
 */

.INCLUDE <m328pdef.inc> 

.DSEG
A:     .BYTE 1
B:     .BYTE 1
C:     .BYTE 2

.CSEG
Adder816s:
    ; load
    clr  r17       ;  0:A
	lds  r16,A     ; First 8 bits are A
	clr  r19       ;  0:B
	lds  r18,B     ; First 8 bits are B
	; make variables 16-bit
	sbrc r16,7
	ser  r17
	sbrc r18,7
	ser  r19
	;add
	add  r16,r18
	adc  r17,r19
	;store
	sts  C,r16     ; store the least significant byte
	sts  C+1,r17   ; store most significant bytes
	rjmp Adder816s
